<template>
  <div>
    <div id="nav">
      <Header />
    </div>
    <div class="container-fluid">
      <h1>Fil des messages</h1>
      <div class="container" v-if="$store.state.isUserLoggedIn">
        <div
          class="message"
          v-for="message in messages"
          :key="message.id"
        >
          <div class="title">
            {{ message.title }}
          </div>
          <div class="author">- {{ message.author }} -</div>

          <div class="body">
            {{ message.body }}
          </div>
          <div class="date">
            {{ message.date }}
          </div>
          <div v-if="message.author == author || userRole == 'admin'">
            <button @click="deleteMessage(message.id, message.author)">Supprimer</button>
          </div>
        </div>
      </div>

      <div class="notconnectedMsg" v-else>
        <p>Vous devez être connecté pour avoir accès à cette page</p>
        <router-link class="user-link" to="/"
          >S'inscrire / Se connecter</router-link
        >
      </div>
    </div>
  </div>
</template>

<script>
import MessagesService from "@/services/MessagesService";
import Header from "@/components/Header";
import axios from "axios";

export default {
  name: "messages",
  components: {
    Header,
  },

  data() {
    return {
      messages: [],
      date: "",
      author: "",
      messageId: "",
      userRole: "",
    };
  },
  async mounted() {
    // do a request once the page is loaded to the backend
    try {
      const token = localStorage.getItem("token");
      const username = localStorage.getItem("username");
      this.author = username;
      const userRole = localStorage.getItem("userRole");
      this.userRole = userRole;
      if (token !== null) {
        this.$store.dispatch("setToken", token);
        axios.defaults.headers.common["Authorization"] = token;
        const response = await MessagesService.index();
        this.messages = response.data;
      }
    } catch (error) {
      if (error.response.status == 403) {
        localStorage.removeItem("token");
        this.$store.dispatch("setToken", null);
      } else {
        this.error = error.response.data.error;
      }
    }
  },

  methods: {
    deleteMessage: async function (messageId, messageAuthor) {
     try {
       if (messageAuthor == this.author || this.userRole == 'admin') {
        console.log(messageId)
        await MessagesService.deleteMessage(messageId);
        this.$router.go();
        }
      } catch (error) {
        this.error = error.response.data.error;
      }
    },
  },

};
</script>

<style scoped>
h1 {
  color: #d1515a;
  margin-bottom: 50px;
}
.message {
  margin: 20px 0;
  width: 50%;
  margin: 0 auto;
  border: solid 0.1rem #091f43;
  border-radius: 10px;
  margin-bottom: 20px;
  padding: 20px 10px;
  color: #091f43;
}
.title,
.author,
.body {
  margin-bottom: 8px;
}
.title {
  font-weight: bold;
}
.author {
  font-style: italic;
}
.date {
  font-size: 0.8rem;
}
button {
  margin-top: 10px;
  border-radius: 10px;
  padding: 10px 50px;
  font-size: 0.9rem;
  background-color: #091f43;
  color: white;
}
@media (min-width: 400px) and (max-width: 985px) {
  h1 {
    margin-top: 20px;
  }
  .message {
    width: 80%;
    padding: 20px 10px;
  }
}
@media (max-width: 399px) {
  h1 {
    margin-top: 20px;
  }
  .message {
    width: 90%;
  }
}
</style>

